/* draw interesting lines on screen.  based on uSoft Quick C manual */
/* interesting bits JPB 2/23/92 */

#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include <math.h>
#include <conio.h>

#define ESC '/033'
#define FALSE 0
#define TRUE 1
#define D double

float rnd();            /* returns random number between 0 and 1 */
void line3d(D x1, D y1, D z1, D x2, D y2, D z2);

double ex, ey, ez;      /* eye coordinate */

main (int argc, char *argv[])
{
	struct videoconfig vc;
	int mode = _VRES16COLOR;   /* highest resolution supported:640x480 */
	float nx, ny, x, y, val, r, data, tx, offset;
	short xc, yc, c, i, j;
	D eystart, eyinc;
	D x0, y0, z0, x1, y1, z1;
	D zfar;
	short xsize, ysize;
	int firstone;

	if (argc > 1)
		mode = atoi(argv[1]);
	if (_setvideomode(mode) == 0)
	  {
	  printf("Can't open mode %d\n", mode);
	  exit(1);
	  }
	_getvideoconfig(&vc);
	nx = vc.numxpixels;
	ny = vc.numypixels;

	_selectpalette(0);
	_setbkcolor(_BLACK);
	_setcolor(15);

	/* viewpoint 0,0,0 in +z direction */

      ex = 0; ey = 0.2; ez = 0;
      zfar = 6.4;
      eystart = 2;
      eyinc = -0.02;
  for (j=0;j<4;j++) {
    eystart = -eystart;
    eyinc = -eyinc;
    ey = eystart;
    for (i=0; i < 200; i++) {
	ey += eyinc;
	_clearscreen(_GCLEARSCREEN);
	x0 = -1.5; y0 = 0.2; z0 = 2;
	x1 = 1.5; y1 = 0.2; z1 = 2;
	  x0 = -1.5; x1 = 1.5; y0 = 0;
	  for ( z0=2; z0<zfar; z0 += 0.2) {
	    line3d(x0,y0,z0,x1,y0,z0);
	  }
	  z0 = 2; z1 = zfar;
	  for ( x0= -1.5; x0<= 1.5; x0 += 0.2) {
	    line3d(x0,y0,z0,x0,y0,z1);
	  } /* end for x0 */
     } /* end for ey */
  } /* end for j */

	_settextposition(24,0);
	_settextcolor(15);
	_outtext("Strike any key to terminate.");
	getch();
	_setvideomode(_DEFAULTMODE);
}

float rnd()    /* returns random number between 0.0 and 1.0 */
{
  return((float) rand() / 32767.0);
}

void line3d(D x1, D y1, D z1, D x2, D y2, D z2)
{
 short xs1,xs2,ys1,ys2;

 x1 -= ex; y1 -= ey; z1 -= ez;   /* transform to eye coordinate */
 x2 -= ex; y2 -= ey; z2 -= ez;

 xs1 = (short) (320*x1/z1) + 320;
 ys1 = (short) (240*y1/z1) + 240;
 xs2 = (short) (320*x2/z2) + 320;
 ys2 = (short) (240*y2/z2) + 240;
 _moveto(xs1,ys1);
 _lineto(xs2,ys2);
}
